#pragma once
#include "oaidl.h"
#include "ocidl.h"
#include "DispEx.h"

/**
* IDispatch̃bp[łB
*/
class DispatchWrapper
{
public:

	/**
	* \z܂B
	*/
	DispatchWrapper(IDispatch* pDispatch, HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~DispatchWrapper(void);

	/**
	* IDispatch擾܂B
	*/
	HRESULT GetDispatch(IDispatch** ppDisp);

	/**
	* o擾܂B
	*/
	HRESULT GetMemberCount(UINT* pCount);

	/**
	* o擾܂B
	*/
	HRESULT GetMemberName(UINT index, string& name);

	/**
	* o^Cv擾܂B
	*/
	HRESULT GetMemberWFlags(UINT index, WORD* pWFlags);

	/**
	* p[^擾܂B
	*/
	HRESULT GetMemberParamCount(UINT memberIndex, UINT* pCount);

	/**
	* p[^擾܂B
	*/
	HRESULT GetMemberParamType(UINT memberIndex, UINT paramIndex, VARTYPE* pVarType);

	/**
	* ߂l擾܂B
	*/
	HRESULT GetMemberReturnType(UINT memberIndex, VARTYPE* pVarType);

	/**
	* os܂B
	*/
	HRESULT Invoke(UINT memberIndex, DISPPARAMS* pParams, VARIANT* pResult);

	/**
	* ܂B
	*/
	HRESULT FindMember(const char* name, WORD wFlags, UINT* pIndex);

	/**
	* BSTRstringIuWFNg擾܂B
	*/
	static HRESULT GetStringFromBSTR(string& value, BSTR bstr);

	/**
	* stringBSTRIuWFNg擾܂B
	*/
	static HRESULT GetBSTRFromString(BSTR* pBSTR, const char* value);

private:

	/**
	* o񋓂܂B
	*/
	HRESULT EnumMembers();

	/**
	* ȍێ܂B
	*/
	class Member
	{
	public:

		/**
		* \z܂B
		*/
		Member(DispatchWrapper* pOwner, ITypeInfo* pTypeInfo, UINT index, MEMBERID memid, INVOKEKIND kind, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~Member();

		/**
		* O擾܂B
		*/
		HRESULT GetName(string& name);

		/**
		* p[^擾܂B
		*/
		HRESULT GetParamCount(UINT* pCount);

		/**
		* p[^擾܂B
		*/
		HRESULT GetParamType(UINT index, VARTYPE* pVarType);

		/**
		* ߂l擾܂B
		*/
		HRESULT GetReturnType(VARTYPE* pVarType);

		/**
		* os܂B
		*/
		HRESULT Invoke(DISPPARAMS* pParams, VARIANT* pResult);

		/**
		* Ăяo^Cv擾܂B
		*/ 
		HRESULT GetWFlags(WORD* pWFlags);

	private:

		/**
		* ܂B
		*/
		HRESULT Init();

		/**
		* O܂B
		*/
		HRESULT InitName();

		/**
		* p[^܂B
		*/
		HRESULT InitParams();

		/**
		* LIuWFNgێ܂B
		*/
		DispatchWrapper* m_pOwner;

		/**
		* CfbNXێ܂B
		*/
		UINT m_iIndex;

		/**
		* Oێ܂B
		*/
		string m_name;

		/**
		* ITypeInfoێ܂B
		*/
		ITypeInfo* m_pTypeInfo;

		/**
		* IDێ܂B
		*/
		MEMBERID m_memId;

		/**
		* Ăяo^Cvێ܂B
		*/
		INVOKEKIND m_kind;

		/**
		* p[^̌^ێ܂B
		*/
		vector<VARTYPE> m_params;

		/**
		* ߂l̃^Cvێ܂B
		*/
		VARTYPE m_returnType;
	};

	/**
	* Dispatchێ܂B
	*/
	IDispatch* m_pDispatch;

	/**
	* oꗗێ܂B
	*/
	vector<Member*> m_members;
};
