
#include "ARGBaseUnknown.h"
#include "IARGObjectFactory.h"

/**
* IuWFNgt@Ng̒ۃNXłB
*/
class ARGBaseObjectFactory : public ARGBaseUnknown, public IARGObjectFactory
{
public:

	/**
	* \z܂B
	*/
	ARGBaseObjectFactory()
	{
		;
	};

	/**
	* j܂B
	*/
	virtual ~ARGBaseObjectFactory()
	{
		;
	};

	DECLARE_BASE_UNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
	virtual STDMETHODIMP QueryInterface(const IID& riid, void** ppv)
	{
		if(ppv == NULL) {
			return E_POINTER;
		}

		if(riid == IID_IARGObjectFactory) {
			*ppv = static_cast<IARGObjectFactory*>(this);
			AddRef();
			return S_OK;
		}

		return ARGBaseUnknown::QueryInterface(riid, ppv);
	};

	/**
	* IuWFNgOpenGLgp邩ǂ擾܂B
	*/
	virtual STDMETHODIMP UseGL(bool* pValue)
	{
		if(pValue == NULL) {
			return E_POINTER;
		}
		*pValue = false;
		return S_OK;
	};

};
