#pragma once

#include <objbase.h>


/**
* p^[̏Ԃ̗񋓂łB
*/
typedef enum __tagPATTERN_STATE
{
	PATTERN_LOST,
	PATTERN_FOUND,
	PATTERN_CHANGED
}PATTERN_STATE;

// {D8BCC639-4218-453e-87C1-62624E7291CC}
DEFINE_GUID(IID_IARGPatternObserver, 
0xd8bcc639, 0x4218, 0x453e, 0x87, 0xc1, 0x62, 0x62, 0x4e, 0x72, 0x91, 0xcc);

/**
* p^[CxgC^tF[XłB
*/
DECLARE_INTERFACE_(IARGPatternObserver, IUnknown)
{

	/**
	* Cxg̏sȂ܂B
	*/
	STDMETHOD(DispatchChanged)(THIS_ PATTERN_STATE state) PURE;

};

/**
* p^[Ɗ֘AsłB
*/
typedef struct __tagPATTERN_TRANSLATE
{
	double matrix[3][4];
}PATTERN_TRANSLATE;

// {C6C9B20C-F592-4e6a-976B-C426B2D14024}
DEFINE_GUID(IID_IARGPattern, 
0xc6c9b20c, 0xf592, 0x4e6a, 0x97, 0x6b, 0xc4, 0x26, 0xb2, 0xd1, 0x40, 0x24);

/**
* p^[łB
*/
DECLARE_INTERFACE_(IARGPattern, IUnknown)
{

	/**
	* ϊs擾܂B
	*/
	STDMETHOD(GetTranslate)(THIS_ PATTERN_TRANSLATE* pTrans) PURE;

	/**
	* p^[Ďǉ܂B
	*/
	STDMETHOD(AddPatternObserver)(THIS_ IARGPatternObserver* pObserver) PURE;

	/**
	* p^[Ď폜܂B
	*/
	STDMETHOD(RemovePatternObserver)(THIS_ IARGPatternObserver* pObserver) PURE;

};


// {AB7DE7C8-B964-4856-8E39-7F7C6FADF719}
DEFINE_GUID(IID_IARGPatternDetector, 
0xab7de7c8, 0xb964, 0x4856, 0x8e, 0x39, 0x7f, 0x7c, 0x6f, 0xad, 0xf7, 0x19);

/**
* p^[̌ołB
*/
DECLARE_INTERFACE_(IARGPatternDetector, IUnknown)
{

	/**
	* p[^^Cv̌␔擾܂B
	*/
	STDMETHOD(GetParameterTypeCandidateCount)(THIS_ int* pCount) PURE;

	/**
	* p[^^Cv̌₲Ƃ̈̐擾܂B
	*/
	STDMETHOD(GetParameterTypeCount)(THIS_ int candIndex, int* pCount) PURE;

	/**
	* p[^^Cv̌₲Ƃ̈^Cv擾܂B
	*/
	STDMETHOD(GetParameterType)(THIS_ int candIndex, int index, VARTYPE* pVarType) PURE;

	/**
	* IuWFNg𐶐܂B
	*/
	STDMETHOD(Create)(THIS_ VARIANT* pVars, int varCount, IARGPattern** ppObject) PURE;

	/**
	* ܂B
	*/
	STDMETHOD(Process)(THIS_ int width, int height, unsigned char* pData) PURE;

};
