#include "StdAfx.h"
#include "ExternalClock.h"

// \z܂B
ExternalClock::ExternalClock(IARGSyncClock* pClock)
{
	m_pClock = pClock;
	pClock->AddRef();
}

// j܂B
ExternalClock::~ExternalClock(void)
{
	if(m_pClock != NULL) {
		m_pClock->Release();
		m_pClock = NULL;
	}
}

// Đ擾܂B
HRESULT ExternalClock::GetCurrentTimeMS(LONGLONG* pMS)
{
	if(pMS == NULL) {
		return E_POINTER;
	}

	return m_pClock->GetCurrentTimeMS(pMS);
}

// Đǂ擾܂B
HRESULT ExternalClock::IsPlaying(bool* pValue)
{
	if(pValue == NULL) {
		return E_POINTER;
	}
	return m_pClock->IsPlaying(pValue);
}
