#pragma once

#include <plugin/ARGBaseObjectFactory.h>
#include <plugin/IARGPluginEnvironment.h>

/**
* MMDIuWFNgt@NgłB
*/
class MMDObjectFactory : public ARGBaseObjectFactory
{
public:

	/**
	* \z܂B
	*/
	MMDObjectFactory(IARGPluginEnvironment* pEnv);

	/**
	* j܂B
	*/
	virtual ~MMDObjectFactory();

	/**
	* IuWFNgOpenGLgp邩ǂ擾܂B
	*/
	STDMETHODIMP UseGL(bool* pValue);

	/**
	* p[^^Cv̌␔擾܂B
	*/
	STDMETHODIMP GetParameterTypeCandidateCount(int* pCount);

	/**
	* p[^^Cv̌₲Ƃ̈̐擾܂B
	*/
	STDMETHODIMP GetParameterTypeCount(int candIndex, int* pCount);

	/**
	* p[^^Cv̌₲Ƃ̈^Cv擾܂B
	*/
	STDMETHODIMP GetParameterType(int candIndex, int index, VARTYPE* pVarType);

	/**
	* IuWFNg𐶐܂B
	*/
	STDMETHODIMP Create(VARIANT* pVars, int varCount, IARGObject** ppObject);

	/**
	* ΃pX擾܂B
	*/
	HRESULT GetAbsolutePath(const char* path, string& absolutePath);

private:

	/**
	* sێ܂B
	*/
	IARGPluginEnvironment* m_pEnv;

};
