#include "StdAfx.h"
#include "MMDPlugin.h"
#include "MMDObjectFactory.h"

// \z܂B
MMDPlugin::MMDPlugin(void)
{
	;
}

// j܂B
MMDPlugin::~MMDPlugin(void)
{
	;
}

// A^b`܂B
STDMETHODIMP MMDPlugin::Attach(IARGPluginEnvironment* pEnv)
{
	if(pEnv == NULL) {
		return E_POINTER;
	}

	MMDObjectFactory* pFactory = new MMDObjectFactory(pEnv);
	HRESULT hr = pEnv->AddObjectFactory("loadMMD", pFactory);
	if(FAILED(hr)) {
		return hr;
	}

	pFactory->Release();
	pFactory = NULL;

	return pEnv->PrintConsole("Registered: MMD");
}

// ܂B
STDMETHODIMP MMDPlugin::Detach()
{
	return S_OK;
}
