#pragma once

#include <plugin/ARGBasePatternDetector.h>
#include <plugin/ARGBasePattern.h>

/**
* eXgp̃p^[ołB
*/
class TestPatternDetector : public ARGBasePatternDetector
{
public:

	/**
	* \z܂B
	*/
	TestPatternDetector(HRESULT* phr);

	/**
	* j܂B
	*/
	virtual ~TestPatternDetector();

	/**
	* p[^^Cv̌␔擾܂B
	*/
	STDMETHODIMP GetParameterTypeCandidateCount(int* pCount);

	/**
	* p[^^Cv̌₲Ƃ̈̐擾܂B
	*/
	STDMETHODIMP GetParameterTypeCount(int candIndex, int* pCount);

	/**
	* p[^^Cv̌₲Ƃ̈^Cv擾܂B
	*/
	STDMETHODIMP GetParameterType(int candIndex, int index, VARTYPE* pVarType);

	/**
	* IuWFNg𐶐܂B
	*/
	STDMETHODIMP Create(VARIANT* pVars, int varCount, IARGPattern** ppObject);

	/**
	* ܂B
	*/
	STDMETHODIMP Process(int width, int height, unsigned char* pData);

private:

	/**
	* eXgp̃p^[łB
	*/
	class TestPattern : public ARGBasePattern
	{
	public:

		/**
		* \z܂B
		*/
		TestPattern(HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~TestPattern();

		/**
		* ϊs擾܂B
		*/
		STDMETHODIMP GetTranslate(PATTERN_TRANSLATE* pTrans);

		/**
		* p^[Ďǉ܂B
		*/
		STDMETHODIMP AddPatternObserver(IARGPatternObserver* pObserver);

		/**
		* p^[Ď폜܂B
		*/
		STDMETHODIMP RemovePatternObserver(IARGPatternObserver* pObserver);

		/**
		* IDispatch̎B
		*/
		STDMETHODIMP Invoke(DISPID dispIdMember, REFIID riid, LCID  lcid, WORD  wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, unsigned int *puArgErr);

		/**
		* ܂B
		*/
		HRESULT Process(int width, int height, unsigned char* pData);

	private:

		/**
		* ITypeInfo𐶐܂B
		*/
		HRESULT CreateTypeInfo();

		/**
		* Ăяo񐔂ێ܂B
		*/
		int m_iTickCount;

		/**
		* p^[ێ܂B
		*/
		vector<IARGPatternObserver*> m_observers;

	};

	/**
	* p^[ێ܂B
	*/
	vector<TestPattern*> m_patterns;

};
