#pragma once

#include "../IPatternDetector.h"
class ARPattern;
class JSEngineContext;

/**
* ARToolkit̃p^[t@NgłB
*/
class ARJSPatternFactory : public IPatternDetector
{
public:
	
	/**
	* \z܂B
	*/
	ARJSPatternFactory(JSEngineContext* pContext, HRESULT * phr);

	/**
	* j܂B
	*/
	virtual ~ARJSPatternFactory();

	/**
	* j܂B
	*/
	virtual void Destroy();

	/**
	* ̃p[^擾܂B
	*/
	HRESULT GetCreateParamCount(int* pCount);

	/**
	* p^[擾܂B
	*/
	HRESULT GetCount(int* pCount);

	/**
	* p^[擾܂B
	*/
	HRESULT Get(int index, IJSObject** ppObject);

	/**
	* p^[ǉ܂B
	*/
	HRESULT Create(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

	/**
	* p^[̃Xg擾܂B
	*/
	HRESULT GetPatterns(vector<ARPattern*>& pattern);

	/**
	* osȂ܂B
	*/
	virtual HRESULT Process(const CAPTURE_IMAGE* pImage);

private:

	/**
	* p^[ׂč폜܂B
	*/
	void DestroyPatterns();

	/**
	* ReLXgێ܂B
	*/
	JSEngineContext* m_pContext;

	/**
	* p^[ێ܂B
	*/
	vector<ARPattern*> m_patterns;

};
