#include "StdAfx.h"
#include "WorkerThread.h"
#include <process.h>

// \z܂B
WorkerThread::WorkerThread()
{
}

// j܂B
WorkerThread::~WorkerThread()
{
}

// WorkerJn܂B
HRESULT WorkerThread::Start(IWorker* pWorker)
{
	if(pWorker == NULL) {
		return E_POINTER;
	}

	uintptr_t ret = _beginthread(RunWorker, 0, pWorker);
	if(ret <= 0) {
		return E_FAIL;
	}
	return S_OK;
}

// Workers܂B
void WorkerThread::RunWorker(void* pWorkerPtr)
{
	IWorker* pWorker = (IWorker*) pWorkerPtr;

	HRESULT hr = pWorker->Invoke();
	pWorker->Destroy();
	pWorker = NULL;

	if(FAILED(hr)) {
		printf("ERROR: %08x\n" + hr);
	}
	_endthread();
}
