#pragma once

#include "../common/IImage.h"
#include "../common/AbstractProperty.h"

/**
* Pȉ摜IuWFNgB
*/
class AbstractImage : public IImage
{
public:

	/**
	* \z܂B
	*/
	AbstractImage(int width, int height);

	/**
	* j܂B
	*/
	virtual ~AbstractImage();

	/**
	* 摜ŐV̏ԂɍXV܂B
	*/
	virtual HRESULT Refresh();

	/**
	* 擾܂B
	*/
	virtual int GetWidth();

	/**
	* 擾܂B
	*/
	virtual int GetHeight();

	/**
	* Materialp̃At@l擾܂B
	*/
	virtual double GetMaterialAlpha();

	/**
	* Dirtyǂ𔻒肵܂B
	*/
	virtual HRESULT IsDirty(bool* pDirty);

	/**
	* Dirtyǂݒ肵܂B
	*/
	virtual HRESULT SetDirty(bool dirty);

	/**
	* vpeB擾܂B
	*/
	virtual HRESULT GetProperty(INamedProperty** ppProp);
	
protected:

	class PropertyImpl;

	/**
	* vpeBIuWFNg𐶐܂B
	*/
	virtual PropertyImpl* CreateProperty();

	/**
	* vpeB̎łB
	*/
	class PropertyImpl : public AbstractNamedProperty
	{
	public:

		/**
		* \z܂B
		*/
		PropertyImpl(AbstractImage* pOwner);

		/**
		* j܂B
		*/
		virtual ~PropertyImpl();

		/**
		* j܂B
		*/
		virtual void Destroy();

		/**
		* ܂B
		*/
		virtual HRESULT Init();

	protected:
		
		/**
		* ̃vpeB擾܂B
		*/
		virtual HRESULT GetDoubleProperty(const char* name, double* pValue);
		
		/**
		* ̃vpeBݒ肵܂B
		*/
		virtual HRESULT SetDoubleProperty(const char* name, double value);

	private:

		/**
		* I[i[ێ܂B
		*/
		AbstractImage* m_pOwner;
	};

	/**
	* ێ܂B
	*/
	int m_iWidth;

	/**
	* ێ܂B
	*/
	int m_iHeight;

	/**
	* At@ێ܂B
	*/
	double m_dAlpha;

	/**
	* vpeBێ܂B
	*/
	PropertyImpl* m_pProp;

	/**
	* Dirtyǂێ܂B
	*/
	bool m_bDirty;
};
