#pragma once

#include "IJSCode.h"

class IJSObject;
class IJSFunction;

/**
* ReLXg̊ĎpIuWFNgB
*/
class IJSContextNotify
{
public:

	/**
	* A[g\Ȃ܂B
	*/
	virtual HRESULT OnAlert(const char* message) = 0;

	/**
	* G[\Ȃ܂B
	*/
	virtual HRESULT OnError(const char* message, const char* filename, unsigned int lineno, const char* token) = 0;

	/**
	* s\Ȃ܂B
	*/
	virtual HRESULT OnPrintLine(const char* message) = 0;

};

/**
* JavaScriptReLXg̃C^tF[XB
*/
class IJSContext
{
public:

	/**
	* ̃IuWFNgj܂B
	*/
	virtual void Destroy() = 0;

	/**
	* ʒmIuWFNgݒ肵܂B
	*/
	virtual HRESULT SetNotify(IJSContextNotify* pNotify) = 0;

	/**
	* R[hs܂B
	*/
	virtual HRESULT Evaluate(IJSCode* pCode) = 0;

	/**
	* \񂵂܂B
	*/
	virtual HRESULT InvokeAsync(IJSFunction* pFunction) = 0;

	/**
	* \񂳂Ă鏈s܂B
	*/
	virtual HRESULT ProcessAsync() = 0;

	/**
	* URL擾܂B
	*/
	virtual HRESULT GetAbsoluteURL(const char* path, string& url) = 0;

	/**
	* {ƂȂURLݒ肵܂B
	*/
	virtual HRESULT SetBaseURL(const char* url) = 0;

	/**
	* {ƂȂURL擾܂B
	*/
	virtual HRESULT GetBaseURL(string& url) = 0;

};