#pragma once
#define _CRTDBG_MAP_ALLOC

#ifdef LIBARBROWSER_EXPORTS
#define DLL_DECL   __declspec(dllexport) 
#else
#define DLL_DECL   __declspec(dllimport) 
#endif

// 

#define PREPARE_DEBUG() \
    _CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_DEBUG); \
    _CrtSetReportMode(_CRT_ERROR, _CRTDBG_MODE_DEBUG); \
    _CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_DEBUG); \
    _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF|_CRTDBG_LEAK_CHECK_DF);

// HRESULT
#include <comutil.h>

// STL
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <iostream>
using namespace std;
