#pragma once

#include <objbase.h>
#include "IARGObjectFactory.h"
#include "IARGPatternDetector.h"

// {BE35A2CD-7680-4363-A73F-D28FFCE3113E}
DEFINE_GUID(IID_IARGWorker, 
0xbe35a2cd, 0x7680, 0x4363, 0xa7, 0x3f, 0xd2, 0x8f, 0xfc, 0xe3, 0x11, 0x3e);

/**
* [J[łB
*/
DECLARE_INTERFACE_(IARGWorker, IUnknown)
{

	/**
	* s܂B
	* G[̓XbĥȂ΂Ȃ܂B
	*/
	STDMETHOD(Invoke)(THIS_) PURE;

};

// {42FA7C6C-2A36-44ad-B47B-E5220A919949}
DEFINE_GUID(IID_IARGPluginEnvironment, 
0x42fa7c6c, 0x2a36, 0x44ad, 0xb4, 0x7b, 0xe5, 0x22, 0xa, 0x91, 0x99, 0x49);

/**
* vOC̎słB
*/
DECLARE_INTERFACE_(IARGPluginEnvironment, IUnknown)
{

	/**
	* pX擾܂B
	*/
	STDMETHOD(GetRealPath)(THIS_ const char* relativePath, char* absolutePath, int maxLen, int* pLen) PURE;

	/**
	* [J[s܂B
	*/
	STDMETHOD(InvokeWorker)(THIS_ IARGWorker* pWorker) PURE;

	/**
	* vpeBǉ܂B
	*/
	STDMETHOD(AddProperty)(THIS_ const char* name, IDispatch* pDisp) PURE;

	/**
	* IuWFNgt@Ngǉ܂B
	*/
	STDMETHOD(AddObjectFactory)(THIS_ const char* name, IARGObjectFactory* pObjectFactory) PURE;

	/**
	* p^[oǉ܂B
	*/
	STDMETHOD(AddPatternDetector)(THIS_ const char* name, IARGPatternDetector* pPatternDetector) PURE;

	/**
	* R\[ɕo͂܂B
	*/
	STDMETHOD(PrintConsole)(THIS_ const char* text) PURE;

};
