#pragma once

#include "BaseTypes.h"

/**
* OvZԂ`܂B
*/
#define MMD_BEZIER_DIV_NUM	16

/**
* xWFȐłB
*/
class BezierCurve
{
private:

	/**
	* YlvZ܂B
	*/
	static HRESULT CalcYValue(float x, const MMD_VECTOR2* p1, const MMD_VECTOR2* p2, float* pValue);

public:

	/**
	* \z܂B
	*/
	BezierCurve(const MMD_VECTOR2* p1, const MMD_VECTOR2* p2, HRESULT* phr);

	/**
	* j܂B
	*/
	~BezierCurve();

	/**
	* l擾܂B
	*/
	HRESULT GetValue(float x, float* pY);

private:

	/**
	* lێ܂B
	*/
	float m_values[MMD_BEZIER_DIV_NUM + 1];

	/**
	* `ωǂێ܂B
	*/
	bool m_bLinear;

};
